diff --git a/base/java-tools/src/com/netscape/cmstools/user/UserRemoveMembershipCLI.java b/base/java-tools/src/com/netscape/cmstools/cli/SubsystemCLI.java
similarity index 52%
copy from base/java-tools/src/com/netscape/cmstools/user/UserRemoveMembershipCLI.java
copy to base/java-tools/src/com/netscape/cmstools/cli/SubsystemCLI.java
index 26a5a6eec5222b98718df1f5a524d364970ac3ed..310a4c29c5c394f3f2bae4e887f9322df54cde0d 100644
--- a/base/java-tools/src/com/netscape/cmstools/user/UserRemoveMembershipCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cli/SubsystemCLI.java
@@ -16,39 +16,49 @@
 // All rights reserved.
 // --- END COPYRIGHT BLOCK ---
 
-package com.netscape.cmstools.user;
+package com.netscape.cmstools.cli;
+
+import com.netscape.certsrv.client.ClientConfig;
 
-import com.netscape.cmstools.cli.CLI;
-import com.netscape.cmstools.cli.MainCLI;
 
 /**
  * @author Endi S. Dewata
  */
-public class UserRemoveMembershipCLI extends CLI {
+public class SubsystemCLI extends CLI {
 
-    public UserCLI parent;
+    public SubsystemCLI(String name, String description, CLI parent) {
+        super(name, description, parent);
+    }
+
+    public String getFullName() {
+        // do not include parent's name
+        return name;
+    }
+
+    public void init() throws Exception {
+    }
 
-    public UserRemoveMembershipCLI(UserCLI parent) {
-        super("remove-membership", "Remove user membership");
-        this.parent = parent;
+    public void login() throws Exception {
     }
 
-    public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <User ID> <Group ID>", options);
+    public void logout() throws Exception {
     }
 
     public void execute(String[] args) throws Exception {
 
-        if (args.length != 2) {
-            printHelp();
-            System.exit(1);
+        init();
+
+        try {
+            // login if username or nickname is specified
+            ClientConfig config = getClient().getConfig();
+            if (config.getUsername() != null || config.getCertNickname() != null) {
+                login();
+            }
+
+            super.execute(args);
+
+        } finally {
+            logout();
         }
-
-        String userID = args[0];
-        String groupID = args[1];
-
-        parent.client.removeUserMembership(userID, groupID);
-
-        MainCLI.printMessage("Deleted membership in group \""+groupID+"\"");
     }
 }
diff --git a/base/java-tools/src/com/netscape/cmstools/cli/TPSCLI.java b/base/java-tools/src/com/netscape/cmstools/cli/TPSCLI.java
index 4dd7e208cd73894f7abecf487baeafb863c32f4c..1f10e959a31bed16a440d1867e4f0909ab98ccb5 100644
--- a/base/java-tools/src/com/netscape/cmstools/cli/TPSCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/cli/TPSCLI.java
@@ -18,92 +18,46 @@
 
 package com.netscape.cmstools.cli;
 
-import org.apache.commons.lang.StringUtils;
-
+import com.netscape.certsrv.client.Client;
 import com.netscape.certsrv.tps.TPSClient;
 import com.netscape.cmstools.token.TokenCLI;
 
 /**
  * @author Endi S. Dewata
  */
-public class TPSCLI extends CLI {
+public class TPSCLI extends SubsystemCLI {
 
-    public MainCLI mainCLI;
     public TPSClient tpsClient;
 
     public TPSCLI(MainCLI mainCLI) {
         super("tps", "TPS management commands", mainCLI);
-        this.mainCLI = mainCLI;
 
         addModule(new TokenCLI(this));
     }
 
-    public void printHelp() {
-
-        System.out.println("Commands:");
-
-        int leftPadding = 1;
-        int rightPadding = 25;
-
-        for (CLI module : modules.values()) {
-            String label = name + "-" + module.getName();
-
-            int padding = rightPadding - leftPadding - label.length();
-            if (padding < 1)
-                padding = 1;
-
-            System.out.print(StringUtils.repeat(" ", leftPadding));
-            System.out.print(label);
-            System.out.print(StringUtils.repeat(" ", padding));
-            System.out.println(module.getDescription());
-        }
-    }
-
-    public void execute(String[] args) throws Exception {
-
-        tpsClient = new TPSClient(mainCLI.client);
-
-        if (args.length == 0) {
-            printHelp();
-            System.exit(1);
-        }
-
-        String command = args[0];
-        String moduleName;
-        String moduleCommand;
-
-        // If a command contains a '-' sign it will be
-        // split into module name and module command.
-        // Otherwise it's a single command.
-        int i = command.indexOf('-');
-        if (i >= 0) { // <module name>-<module command>
-            moduleName = command.substring(0, i);
-            moduleCommand = command.substring(i+1);
-
-        } else { // <command>
-            moduleName = command;
-            moduleCommand = null;
-        }
-
-        // get command module
-        if (verbose) System.out.println("Module: " + moduleName);
-        CLI module = getModule(moduleName);
-        if (module == null) {
-            throw new Error("Invalid module \"" + moduleName + "\".");
-        }
-
-        // prepare module arguments
-        String[] moduleArgs;
-        if (moduleCommand != null) {
-            moduleArgs = new String[args.length];
-            moduleArgs[0] = moduleCommand;
-            System.arraycopy(args, 1, moduleArgs, 1, args.length-1);
-
+    public String getFullName() {
+        if (parent instanceof MainCLI) {
+            // do not include MainCLI's name
+            return name;
         } else {
-            moduleArgs = new String[args.length-1];
-            System.arraycopy(args, 1, moduleArgs, 0, args.length-1);
+            return parent.getFullName() + "-" + name;
         }
+    }
 
-        module.execute(moduleArgs);
+    public void init() throws Exception {
+        client = parent.getClient();
+        tpsClient = new TPSClient(client);
+    }
+
+    public void login() {
+        tpsClient.login();
+    }
+
+    public void logout() {
+        tpsClient.logout();
+    }
+
+    public Client getClient(String name) {
+        return tpsClient.getClient(name);
     }
 }
diff --git a/base/java-tools/src/com/netscape/cmstools/client/ClientCLI.java b/base/java-tools/src/com/netscape/cmstools/client/ClientCLI.java
index 34d09f33ca442d888285e00703c6016084ab76bc..1b54bff8d378d5ef6808f6251585e38d99df3eb7 100644
--- a/base/java-tools/src/com/netscape/cmstools/client/ClientCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/client/ClientCLI.java
@@ -20,7 +20,6 @@ package com.netscape.cmstools.client;
 
 import java.util.Arrays;
 
-import org.apache.commons.lang.StringUtils;
 import org.mozilla.jss.crypto.X509Certificate;
 
 import com.netscape.certsrv.dbs.certdb.CertId;
@@ -32,40 +31,27 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class ClientCLI extends CLI {
 
-    public MainCLI parent;
-
-    public ClientCLI(MainCLI parent) {
-        super("client", "Client management commands");
-        this.parent = parent;
+    public ClientCLI(CLI parent) {
+        super("client", "Client management commands", parent);
 
         addModule(new ClientFindCertCLI(this));
         addModule(new ClientImportCertCLI(this));
         addModule(new ClientRemoveCertCLI(this));
     }
 
-    public void printHelp() {
-
-        System.out.println("Commands:");
-
-        int leftPadding = 1;
-        int rightPadding = 25;
-
-        for (CLI module : modules.values()) {
-            String label = name + "-" + module.getName();
-
-            int padding = rightPadding - leftPadding - label.length();
-            if (padding < 1)
-                padding = 1;
-
-            System.out.print(StringUtils.repeat(" ", leftPadding));
-            System.out.print(label);
-            System.out.print(StringUtils.repeat(" ", padding));
-            System.out.println(module.getDescription());
+    public String getFullName() {
+        if (parent instanceof MainCLI) {
+            // do not include MainCLI's name
+            return name;
+        } else {
+            return parent.getFullName() + "-" + name;
         }
     }
 
     public void execute(String[] args) throws Exception {
 
+        client = parent.getClient();
+
         if (args.length == 0) {
             printHelp();
             System.exit(1);
diff --git a/base/java-tools/src/com/netscape/cmstools/client/ClientFindCertCLI.java b/base/java-tools/src/com/netscape/cmstools/client/ClientFindCertCLI.java
index 80690b7d09874740ee96b818a6c9258eee067565..f4057c67a66c0d5c2266fb35223db3623d5e2a18 100644
--- a/base/java-tools/src/com/netscape/cmstools/client/ClientFindCertCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/client/ClientFindCertCLI.java
@@ -29,19 +29,21 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class ClientFindCertCLI extends CLI {
 
-    public ClientCLI parent;
+    public ClientCLI clientCLI;
 
-    public ClientFindCertCLI(ClientCLI parent) {
-        super("find-cert", "Find certificates in client security database");
-        this.parent = parent;
+    public ClientFindCertCLI(ClientCLI clientCLI) {
+        super("find-cert", "Find certificates in client security database", clientCLI);
+        this.clientCLI = clientCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " [OPTIONS]", options);
+        formatter.printHelp(getFullName() + " [OPTIONS]", options);
     }
 
     public void execute(String[] args) throws Exception {
 
+        client = clientCLI.getClient();
+
         options.addOption(null, "ca", false, "Find CA certificates only");
 
         CommandLine cmd = null;
@@ -56,9 +58,9 @@ public class ClientFindCertCLI extends CLI {
 
         X509Certificate[] certs;
         if (cmd.hasOption("ca")) {
-            certs = parent.parent.client.getCACerts();
+            certs = client.getCACerts();
         } else {
-            certs = parent.parent.client.getCerts();
+            certs = client.getCerts();
         }
 
         if (certs == null || certs.length == 0) {
diff --git a/base/java-tools/src/com/netscape/cmstools/client/ClientImportCertCLI.java b/base/java-tools/src/com/netscape/cmstools/client/ClientImportCertCLI.java
index e89f954bb5fc4a4b54cd811d730d82a217e00b27..cbd55079a9b5fa194b7257f567be032976007d8b 100644
--- a/base/java-tools/src/com/netscape/cmstools/client/ClientImportCertCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/client/ClientImportCertCLI.java
@@ -34,19 +34,21 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class ClientImportCertCLI extends CLI {
 
-    public ClientCLI parent;
+    public ClientCLI clientCLI;
 
-    public ClientImportCertCLI(ClientCLI parent) {
-        super("import-cert", "Import certificate into client security database");
-        this.parent = parent;
+    public ClientImportCertCLI(ClientCLI clientCLI) {
+        super("import-cert", "Import certificate into client security database", clientCLI);
+        this.clientCLI = clientCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " [OPTIONS]", options);
+        formatter.printHelp(getFullName() + " [OPTIONS]", options);
     }
 
     public void execute(String[] args) throws Exception {
 
+        client = clientCLI.getClient();
+
         Option option = new Option(null, "cert", true, "Import certificate file");
         option.setArgName("path");
         options.addOption(option);
@@ -90,11 +92,11 @@ public class ClientImportCertCLI extends CLI {
             isCACert = true;
 
         } else if (importFromCAServer) {
-            ClientConfig config = parent.parent.config;
+            ClientConfig config = client.getConfig();
             String caServerURI = "http://" + config.getServerURI().getHost() + ":8080/ca";
 
             if (verbose) System.out.println("Downloading CA certificate from " + caServerURI + ".");
-            bytes = parent.parent.client.downloadCACertChain(caServerURI);
+            bytes = client.downloadCACertChain(caServerURI);
 
             isCACert = true;
 
@@ -107,11 +109,11 @@ public class ClientImportCertCLI extends CLI {
         // import the certificate
         if (isCACert) {
             if (verbose) System.out.println("Importing CA certificate.");
-            cert = parent.parent.client.importCACertPackage(bytes);
+            cert = client.importCACertPackage(bytes);
 
         } else {
             if (verbose) System.out.println("Importing certificate.");
-            cert = parent.parent.client.importCertPackage(bytes, parent.parent.client.config.getCertNickname());
+            cert = client.importCertPackage(bytes, client.config.getCertNickname());
         }
 
         MainCLI.printMessage("Imported certificate \"" + cert.getNickname() + "\"");
diff --git a/base/java-tools/src/com/netscape/cmstools/client/ClientRemoveCertCLI.java b/base/java-tools/src/com/netscape/cmstools/client/ClientRemoveCertCLI.java
index fab4296314243c21ad6f718452d357c4dec1799f..be4456115f05df7947803893438132e81d1dcf94 100644
--- a/base/java-tools/src/com/netscape/cmstools/client/ClientRemoveCertCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/client/ClientRemoveCertCLI.java
@@ -28,15 +28,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class ClientRemoveCertCLI extends CLI {
 
-    public ClientCLI parent;
+    public ClientCLI clientCLI;
 
-    public ClientRemoveCertCLI(ClientCLI parent) {
-        super("remove-cert", "Remove certificate from client security database");
-        this.parent = parent;
+    public ClientRemoveCertCLI(ClientCLI clientCLI) {
+        super("remove-cert", "Remove certificate from client security database", clientCLI);
+        this.clientCLI = clientCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <nickname>", options);
+        formatter.printHelp(getFullName() + " <nickname>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -58,8 +58,10 @@ public class ClientRemoveCertCLI extends CLI {
             System.exit(1);
         }
 
+        client = clientCLI.getClient();
+
         String nickname = cmdArgs[0];
-        parent.parent.client.removeCert(nickname);
+        client.removeCert(nickname);
 
         MainCLI.printMessage("Removed certificate \"" + nickname + "\"");
    }
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupAddCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupAddCLI.java
index b4814fbcc378be55575ec06132a493d9a1c64cfb..a29ce62ef048750c79f7768ed89e62dfc7d198ff 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupAddCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupAddCLI.java
@@ -30,15 +30,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class GroupAddCLI extends CLI {
 
-    public GroupCLI parent;
+    public GroupCLI groupCLI;
 
-    public GroupAddCLI(GroupCLI parent) {
-        super("add", "Add group");
-        this.parent = parent;
+    public GroupAddCLI(GroupCLI groupCLI) {
+        super("add", "Add group", groupCLI);
+        this.groupCLI = groupCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " <Group ID> [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -72,7 +72,7 @@ public class GroupAddCLI extends CLI {
         groupData.setID(groupID);
         groupData.setDescription(cmd.getOptionValue("description"));
 
-        groupData = parent.client.addGroup(groupData);
+        groupData = groupCLI.groupClient.addGroup(groupData);
 
         MainCLI.printMessage("Added group \""+groupID+"\"");
 
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupAddMemberCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupAddMemberCLI.java
index 36d3c06fd2f87f860ac26b1d5a5fb83960187059..eb2f9bedefe29ed5f57a143ce91b36b1b01a16a2 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupAddMemberCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupAddMemberCLI.java
@@ -27,15 +27,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class GroupAddMemberCLI extends CLI {
 
-    public GroupCLI parent;
+    public GroupCLI groupCLI;
 
-    public GroupAddMemberCLI(GroupCLI parent) {
-        super("add-member", "Add group member");
-        this.parent = parent;
+    public GroupAddMemberCLI(GroupCLI groupCLI) {
+        super("add-member", "Add group member", groupCLI);
+        this.groupCLI = groupCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> <Member ID>", options);
+        formatter.printHelp(getFullName() + " <Group ID> <Member ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -48,7 +48,7 @@ public class GroupAddMemberCLI extends CLI {
         String groupID = args[0];
         String memberID = args[1];
 
-        GroupMemberData groupMemberData = parent.client.addGroupMember(groupID, memberID);
+        GroupMemberData groupMemberData = groupCLI.groupClient.addGroupMember(groupID, memberID);
 
         MainCLI.printMessage("Added group member \""+memberID+"\"");
 
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupCLI.java
index bd8cec7735f8802328d99ae07cbbda3bdbfd8637..d691c432b569de11c03470dde9e816633b90f435 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupCLI.java
@@ -34,12 +34,10 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class GroupCLI extends CLI {
 
-    public MainCLI parent;
-    public GroupClient client;
+    public GroupClient groupClient;
 
-    public GroupCLI(MainCLI parent) {
-        super("group", "Group management commands");
-        this.parent = parent;
+    public GroupCLI(CLI parent) {
+        super("group", "Group management commands", parent);
 
         addModule(new GroupFindCLI(this));
         addModule(new GroupShowCLI(this));
@@ -53,29 +51,19 @@ public class GroupCLI extends CLI {
         addModule(new GroupRemoveMemberCLI(this));
     }
 
-    public void printHelp() {
-
-        System.out.println("Commands:");
-
-        int leftPadding = 1;
-        int rightPadding = 25;
-
-        for (CLI module : modules.values()) {
-            String label = name+"-"+module.getName();
-
-            int padding = rightPadding - leftPadding - label.length();
-            if (padding < 1) padding = 1;
-
-            System.out.print(StringUtils.repeat(" ", leftPadding));
-            System.out.print(label);
-            System.out.print(StringUtils.repeat(" ", padding));
-            System.out.println(module.getDescription());
+    public String getFullName() {
+        if (parent instanceof MainCLI) {
+            // do not include MainCLI's name
+            return name;
+        } else {
+            return parent.getFullName() + "-" + name;
         }
     }
 
     public void execute(String[] args) throws Exception {
 
-        client = new GroupClient(parent.client);
+        client = parent.getClient();
+        groupClient = new GroupClient(client);
 
         if (args.length == 0) {
             printHelp();
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupFindCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupFindCLI.java
index 272e3a8fda0e4c1b2e5610d5b37e089f61e79f2a..7c2361da325841b77fcdcccd0210a8c161511cd2 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupFindCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupFindCLI.java
@@ -33,15 +33,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class GroupFindCLI extends CLI {
 
-    public GroupCLI parent;
+    public GroupCLI groupCLI;
 
-    public GroupFindCLI(GroupCLI parent) {
-        super("find", "Find groups");
-        this.parent = parent;
+    public GroupFindCLI(GroupCLI groupCLI) {
+        super("find", "Find groups", groupCLI);
+        this.groupCLI = groupCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " [FILTER] [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " [FILTER] [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -74,7 +74,7 @@ public class GroupFindCLI extends CLI {
         s = cmd.getOptionValue("size");
         Integer size = s == null ? null : Integer.valueOf(s);
 
-        GroupCollection response = parent.client.findGroups(filter, start, size);
+        GroupCollection response = groupCLI.groupClient.findGroups(filter, start, size);
 
         Collection<GroupData> entries = response.getGroups();
 
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupFindMemberCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupFindMemberCLI.java
index f0498f0d274227b8b0835a5d6e9895cc32c4f079..383e547f31a6656f071d88edbc471b4ab501ee9b 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupFindMemberCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupFindMemberCLI.java
@@ -33,15 +33,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class GroupFindMemberCLI extends CLI {
 
-    public GroupCLI parent;
+    public GroupCLI groupCLI;
 
-    public GroupFindMemberCLI(GroupCLI parent) {
-        super("find-member", "Find group members");
-        this.parent = parent;
+    public GroupFindMemberCLI(GroupCLI groupCLI) {
+        super("find-member", "Find group members", groupCLI);
+        this.groupCLI = groupCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " <Group ID> [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -80,7 +80,7 @@ public class GroupFindMemberCLI extends CLI {
         s = cmd.getOptionValue("size");
         Integer size = s == null ? null : Integer.valueOf(s);
 
-        GroupMemberCollection response = parent.client.findGroupMembers(groupID, start, size);
+        GroupMemberCollection response = groupCLI.groupClient.findGroupMembers(groupID, start, size);
 
         Collection<GroupMemberData> entries = response.getMembers();
 
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupModifyCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupModifyCLI.java
index 2869ce19df1007309871c00a62210736e0da9bb1..b0974d3251356178daed45e8914236589142e233 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupModifyCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupModifyCLI.java
@@ -30,15 +30,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class GroupModifyCLI extends CLI {
 
-    public GroupCLI parent;
+    public GroupCLI groupCLI;
 
-    public GroupModifyCLI(GroupCLI parent) {
-        super("mod", "Modify group");
-        this.parent = parent;
+    public GroupModifyCLI(GroupCLI groupCLI) {
+        super("mod", "Modify group", groupCLI);
+        this.groupCLI = groupCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> [OPTIONS...]", options);
+        formatter.printHelp(getFullName() + " <Group ID> [OPTIONS...]", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -71,7 +71,7 @@ public class GroupModifyCLI extends CLI {
         groupData.setID(groupID);
         groupData.setDescription(cmd.getOptionValue("description"));
 
-        groupData = parent.client.modifyGroup(groupID, groupData);
+        groupData = groupCLI.groupClient.modifyGroup(groupID, groupData);
 
         MainCLI.printMessage("Modified group \""+groupID+"\"");
 
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveCLI.java
index fd9c08893d9d28ac38027b1be9da0c6466c1291b..cc64ed8412952cef995c3a24321a4f940458064c 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveCLI.java
@@ -27,15 +27,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class GroupRemoveCLI extends CLI {
 
-    public GroupCLI parent;
+    public GroupCLI groupCLI;
 
-    public GroupRemoveCLI(GroupCLI parent) {
-        super("del", "Remove group");
-        this.parent = parent;
+    public GroupRemoveCLI(GroupCLI groupCLI) {
+        super("del", "Remove group", groupCLI);
+        this.groupCLI = groupCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID>", options);
+        formatter.printHelp(getFullName() + " <Group ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -47,7 +47,7 @@ public class GroupRemoveCLI extends CLI {
 
         String groupID = args[0];
 
-        parent.client.removeGroup(groupID);
+        groupCLI.groupClient.removeGroup(groupID);
 
         MainCLI.printMessage("Deleted group \""+groupID+"\"");
     }
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveMemberCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveMemberCLI.java
index c12cc892e5d0f0fdef107571c51c7b4b0a8c7d02..ef348404586997cc9f4b9d52e3afc22bd7852699 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveMemberCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupRemoveMemberCLI.java
@@ -26,15 +26,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class GroupRemoveMemberCLI extends CLI {
 
-    public GroupCLI parent;
+    public GroupCLI groupCLI;
 
-    public GroupRemoveMemberCLI(GroupCLI parent) {
-        super("remove-member", "Remove group member");
-        this.parent = parent;
+    public GroupRemoveMemberCLI(GroupCLI groupCLI) {
+        super("remove-member", "Remove group member", groupCLI);
+        this.groupCLI = groupCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> <Member ID>", options);
+        formatter.printHelp(getFullName() + " <Group ID> <Member ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -47,7 +47,7 @@ public class GroupRemoveMemberCLI extends CLI {
         String groupID = args[0];
         String memberID = args[1];
 
-        parent.client.removeGroupMember(groupID, memberID);
+        groupCLI.groupClient.removeGroupMember(groupID, memberID);
 
         MainCLI.printMessage("Deleted group member \""+memberID+"\"");
     }
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupShowCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupShowCLI.java
index 4e8e444210e1978ac711768af0707fa79569c227..c25306a271ed7a3aeb68d92d6a57ae676eba47a2 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupShowCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupShowCLI.java
@@ -27,15 +27,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class GroupShowCLI extends CLI {
 
-    public GroupCLI parent;
+    public GroupCLI groupCLI;
 
-    public GroupShowCLI(GroupCLI parent) {
-        super("show", "Show group");
-        this.parent = parent;
+    public GroupShowCLI(GroupCLI groupCLI) {
+        super("show", "Show group", groupCLI);
+        this.groupCLI = groupCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID>", options);
+        formatter.printHelp(getFullName() + " <Group ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -47,7 +47,7 @@ public class GroupShowCLI extends CLI {
 
         String groupID = args[0];
 
-        GroupData groupData = parent.client.getGroup(groupID);
+        GroupData groupData = groupCLI.groupClient.getGroup(groupID);
 
         MainCLI.printMessage("Group \""+groupID+"\"");
 
diff --git a/base/java-tools/src/com/netscape/cmstools/group/GroupShowMemberCLI.java b/base/java-tools/src/com/netscape/cmstools/group/GroupShowMemberCLI.java
index 47ca43c8f1a8d42a6261001c6b5d62cdc4240329..2f50a6a080bd8a22b485316779ac05a02447e220 100644
--- a/base/java-tools/src/com/netscape/cmstools/group/GroupShowMemberCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/group/GroupShowMemberCLI.java
@@ -27,15 +27,15 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class GroupShowMemberCLI extends CLI {
 
-    public GroupCLI parent;
+    public GroupCLI groupCLI;
 
-    public GroupShowMemberCLI(GroupCLI parent) {
-        super("show-member", "Show group member");
-        this.parent = parent;
+    public GroupShowMemberCLI(GroupCLI groupCLI) {
+        super("show-member", "Show group member", groupCLI);
+        this.groupCLI = groupCLI;
     }
 
     public void printHelp() {
-        formatter.printHelp(parent.name + "-" + name + " <Group ID> <Member ID>", options);
+        formatter.printHelp(getFullName() + " <Group ID> <Member ID>", options);
     }
 
     public void execute(String[] args) throws Exception {
@@ -48,7 +48,7 @@ public class GroupShowMemberCLI extends CLI {
         String groupID = args[0];
         String memberID = args[1];
 
-        GroupMemberData groupMemberData = parent.client.getGroupMember(groupID, memberID);
+        GroupMemberData groupMemberData = groupCLI.groupClient.getGroupMember(groupID, memberID);
 
         MainCLI.printMessage("Group member \""+memberID+"\"");
 
diff --git a/base/java-tools/src/com/netscape/cmstools/key/KeyCLI.java b/base/java-tools/src/com/netscape/cmstools/key/KeyCLI.java
index 0d239624329c4c66cd56b28b00babeb81fdc11ea..de52613eef2db6ff015a7a3f03ec2b32ff506567 100644
--- a/base/java-tools/src/com/netscape/cmstools/key/KeyCLI.java
+++ b/base/java-tools/src/com/netscape/cmstools/key/KeyCLI.java
@@ -20,8 +20,6 @@ package com.netscape.cmstools.key;
 
 import java.util.Arrays;
 
-import org.apache.commons.lang.StringUtils;
-
 import com.netscape.certsrv.key.KeyClient;
 import com.netscape.certsrv.key.KeyDataInfo;
 import com.netscape.certsrv.key.KeyRequestInfo;
@@ -33,41 +31,28 @@ import com.netscape.cmstools.cli.MainCLI;
  */
 public class KeyCLI extends CLI {
 
-    public MainCLI parent;
     public KeyClient keyClient;
 
-    public KeyCLI(MainCLI parent) {
-        super("key", "Key management commands");
-        this.parent = parent;
+    public KeyCLI(CLI parent) {
+        super("key", "Key management commands", parent);
 
         addModule(new KeyFindCLI(this));
         addModule(new KeyRequestFindCLI(this));
     }
 
-    public void printHelp() {
-
-        System.out.println("Commands:");
-
-        int leftPadding = 1;
-        int rightPadding = 25;
-
-        for (CLI module : modules.values()) {
-            String label = name + "-" + module.getName();
-
-            int padding = rightPadding - leftPadding - label.length();
-            if (padding < 1)
-                padding = 1;
-
-            System.out.print(StringUtils.repeat(" ", leftPadding));
-            System.out.print(label);
-            System.out.print(StringUtils.repeat(" ", padding));
-            System.out.println(module.getDescription());
+    public String getFullName() {
+        if (parent instanceof MainCLI) {
+            // do not include MainCLI's name
+            return name;
+        } else {
+            return parent.getFullName() + "-" + name;
         }
     }
 
     public void execute(String[] args) throws Exception {
 
-        keyClient = new KeyClient(parent.client);
+        client = parent.getClient();
+        keyClient = new KeyClient(client);
 
         if (args.length == 0) {
             printHelp();
